package dev.shadowsoffire.apotheosis.util;

import com.mojang.datafixers.kinds.Applicative;
import java.util.function.Function;
import dev.shadowsoffire.placebo.codec.PlaceboCodecs;
import com.mojang.datafixers.kinds.App;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import net.minecraft.world.level.BaseSpawner;
import net.minecraft.world.level.block.entity.SpawnerBlockEntity;
import com.mojang.serialization.Codec;

record SpawnerStats(int spawnDelay, int minDelay, int maxDelay, int spawnCount, int maxNearbyEntities, int spawnRange, int playerRange) {
    public static final Codec<SpawnerStats> CODEC;
    
    public SpawnerStats {
        this(20, 200, 800, 4, 6, 4, 16);
    }
    
    public void apply(final SpawnerBlockEntity entity) {
        final BaseSpawner base = entity.f_59788_;
        base.f_45442_ = this.spawnDelay;
        base.f_45447_ = this.minDelay;
        base.f_45448_ = this.maxDelay;
        base.f_45449_ = this.spawnCount;
        base.f_45451_ = this.maxNearbyEntities;
        base.f_45453_ = this.spawnRange;
        base.f_45452_ = this.playerRange;
    }
    
    static {
        CODEC = RecordCodecBuilder.create(inst -> inst.group((App)PlaceboCodecs.nullableField((Codec)Codec.INT, "spawn_delay", (Object)20).forGetter((Function)SpawnerStats::spawnDelay), (App)PlaceboCodecs.nullableField((Codec)Codec.INT, "min_delay", (Object)200).forGetter((Function)SpawnerStats::minDelay), (App)PlaceboCodecs.nullableField((Codec)Codec.INT, "max_delay", (Object)800).forGetter((Function)SpawnerStats::maxDelay), (App)PlaceboCodecs.nullableField((Codec)Codec.INT, "spawn_count", (Object)4).forGetter((Function)SpawnerStats::spawnCount), (App)PlaceboCodecs.nullableField((Codec)Codec.INT, "max_nearby_entities", (Object)6).forGetter((Function)SpawnerStats::maxNearbyEntities), (App)PlaceboCodecs.nullableField((Codec)Codec.INT, "spawn_range", (Object)4).forGetter((Function)SpawnerStats::spawnRange), (App)PlaceboCodecs.nullableField((Codec)Codec.INT, "player_activation_range", (Object)16).forGetter((Function)SpawnerStats::playerRange)).apply((Applicative)inst, SpawnerStats::new));
    }
}
